p(1).
p(2). 

q(a).
q(b).

r(3, 4, 5).
r(X, Y, Z) :- p(X), q(Y), !, s(Z). 
r(5, 6, 7). 

s(3). 
s(4). 

h(X, Y, Z) :- r(X, Y, Z). 
h(a, b, c).  

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Si planteáis el objetivo 
% ?- h(A,B,C), write([A,B,C]), nl, fail.

% La respuesta será 

%[3,4,5]
%[1,a,3]
%[1,a,4]
%[a,b,c]
%false. 

% Se puede observar que el operador ! elimina de la pila de backtracking 
% los puntos correspondientes a las cláusulas p(2), q(b) y r(5,6,7).

% Esto ocurre por que los predicados p/1 y q/1 están a la izquierda 
% del operador !, y porque la cláusula r(5,6,7) está debajo de 
% la cláusula de r/3 que contiene el operador !. 