long([], 0).
long([ _ | T], N) :- long(T, N1), N is N1 + 1.


pert(X, [X | _ ]).
pert(X, [ _ | L]) :- pert(X, L).


concat([], L, L).
concat([X | L1], L2, [X | L3]) :- concat(L1, L2, L3).


pert_con_resto(X, L, Resto) :- concat(L1, [X | L2], L),
	concat(L1, L2, Resto).


permutacion([], []). 
permutacion(L, [H | T]) :- pert_con_resto(H, L, Resto),
	permutacion(Resto, T).


subconjunto([], []).
subconjunto([H | T], [H | S]) :- subconjunto(T, S).
subconjunto([_ | T], S) :- subconjunto(T, S). 


factores_primos(1, []).
factores_primos(N, [Div | T]) :- nat(Div), Div > 1, 0 is N mod Div,
	N1 is N // Div, factores_primos(N1, T).


nat(0).
nat(N) :- nat(N1), N is N1 + 1. 
